(* use"DG/dialog.sml";
   use"dialog.sml";
   *)



fun set_newcell (c:cellID) (FormKF (_,_,indent,nest,ct')) = 
  FormKF (c, Protect, indent, nest, ct')
  | set_newcell c (PpcKF (_,_,indent,nest,ppc)) = 
  PpcKF (c, Protect, indent, nest, ppc)
  | set_newcell _ New_user = New_user; (*for tests*)
(*val dpst = (DmtUndef,T,SkipNil,DAundf,
                     DPundef,[],999,ACnew);
> val f = FormKF (0,0,empty_cterm');
> set_newcell dpst f;
val it = FormKF (999,0,"empty_cterm'") : inout
*)




(*** change dps ***)

fun set_dph_dct' c (DPform (r,sf,uf,_)) = DPform (r,sf,uf,c)
  | set_dph_dct' c (DPrule (sr,ur,_)  ) = DPrule (sr,ur,c)
  | set_dph_dct' c (DPdoneF (m,f,_)   ) = DPdoneF (m,f,c)
  | set_dph_dct' c (DPdoneR (m,f,_)   ) = DPdoneR (m,f,c);

fun set_dph_dct dct (((c,(dtm,act,dast,cmd,dph,pos))::dps):dps) =
    ((c,(dtm,act,dast,cmd,set_dph_dct' dct dph,pos))::dps):dps;

fun set_done' (DPform (r,sf,uf,c)) =
    DPdoneF (r, if uf = EmptyFoppFK then sf else Form' (FoPpcFK uf), c)
  | set_done' (DPrule (sr,ur,c)) = 
    DPdoneR (if ur = e_mstep_ then sr else ur, EmptyMout, c)
  | set_done' dph = dph;

(* 10.1.01
fun set_next' (DPform  (r,sf,uf,c)) = DPrule (r,e_mstep_,c)
  | set_next' (DPdoneF (r,f,c))     = DPrule (r,e_mstep_,c)
  | set_next' (DPrule  (sr,ur,c))   = DPform (sr,EmptyMout,EmptyFoppFK,c)
  | set_next' (DPdoneR (r,f,c))     = DPform (r,f,EmptyFoppFK,c);
*)


fun set_dast (((c,(dtm,act,_,cmd,dph,pos))::dps):dps) dast =
    ((c,(dtm,act,dast,cmd,set_done' dph,pos))::dps):dps;

fun set_error ((dp as (c,(dtm,act,_,cmd,dph,pos))::dps):dps) =
    ((c,(dtm,act,ErroR,cmd,dph,pos))::dps):dps;
                         (*~~~ used in continue_pattern*)

fun set_done dph pos dast (((c,(dtm,act,_,cmd,_,_))::dps):dps) = 
    ((c,(dtm,act,dast,cmd,dph,pos))::dps):dps;

fun set_broken (((c,(dtm,act,_,cmd,dph,pos))::dps):dps) =
    ((c,(dtm,act,Broken,cmd,dph,pos))::dps):dps;
                          (*~~~ DPform, DPrule used in sel_dtm*)

fun set_cmd cmd (((c,(dtm,act,dast,_,dph,pos))::dps):dps) = 
    ((c,(dtm,act,dast,Some cmd,dph,pos))::dps):dps;

fun set_broken_cmd cmd (((c,(dtm,act,_,_,dph,pos))::dps):dps) = 
    ((c,(dtm,act,Broken,Some cmd,dph,pos))::dps):dps;

(*add to dps due to immediate input of St in resume_*, without adding dat*)
fun add_dps (xxx:dpstate) (((c,(dtm,act,dast,cmd,dph,pos))::dps):dps) =
  ((c,xxx)::(c,(dtm,act,dast,cmd,set_done' dph,pos))::dps):dps;

(*add empty head to dps, for recording user_cmd only*)
fun add_dps_cmd cmd' (((dp as (c,(dtm,act,dast,cmd,dph,pos)))::dps):dps) =
((c,(DtmUndef,ACundef,DAundf,Some cmd',dph,pos))::
 (c,(dtm,act,dast,cmd,set_done' dph,pos))::dps):dps;

(*resume from cmd, no dtm done in do_dtms because of 'NoDtm'*)
fun repeat_dtm_cmd cmd' (((c,(dtm,act,_,cmd,dph,pos))::dps):dps) =
    ((c,(dtm,act,NoDtm,cmd,dph,pos))::
     (c,(DtmUndef,ACundef,DAundf,Some cmd',dph,pos))::dps):dps;

(*add a dtm for do_dtms, without continue_pattern*)
fun add_fix dtm act (( (dp as (c,(_,_,_,_,dph,pos)))::dps):dps) =
    ((c,(dtm,act,FixDtm,None,dph,pos))::dp::dps):dps;





(*create a new cellID for the formula to be output*)
fun app_dat d ((dp as (c,xxx)::dps):dps) f =
  let val (d,c) = getdecr_cellID d;
  in (d, ((c,xxx)::dps):dps, [set_newcell c f]) end;




(* 16.4. ------
fun nxt_leave (((c,(dtm,act,dast,cmd,dph,pos))::dps):dps) =
  ((c,(dtm,act,dast,cmd,dph,pos))::dps):dps; *)




(** decide if an mstep_ / mstep belongs to a hide_.. list **)

fun hide (mI,m) ((pos,_):pos') (p:ptree)
    (Dstate ({rules = hm, pbls = hp, rlss = hr, thms = ht},_,_,_,_)) =
    let val _= 1(*writeln("#### hide: mI = "^mI);
	val _= writeln("#### hide: hm = "^(strs2str hm));
	val _= writeln("#### hide: mI mem hm = "^(bool2str (mI mem hm)));*)
    in
	if mI mem hm orelse 
	    (mI mem specsteps 
	     andalso (snd3 (get_obj g_spec p pos)) mem hp) then true
	else case m of
	    Rewrite_Inst (_, (ID,_)) => ID mem ht
	  | Rewrite (ID,_)           => ID mem ht
	  | Rewrite_Set_Inst (_, ID) => ID mem hr
	  | Rewrite_Set ID           => ID mem hr
	  | _                        => false
    end;
(*> val m = ("Add_Given",
 Add_Given "equality (sqrt (#9 + #4 * x) = sqrt x + sqrt (#5 + x))"):mstep_;
> val p = ([],Pbl):pos';
> proofs:= []; dials:=([],[],[]);
> StdinSML 0 0 0 0 New_User;
> val ([(1,d)],_,_) = !dials;
> StdinSML 1 0 0 0 New_Proof;
> val fmz = [];
> val (dI',pI',mI') =
  ("Script.thy",["Script.thy","squareroot","univariate","equation"],
   ("Script.thy","sqrt-equ-test"));
"--- s1 ---";
> val (_,1,1,1,[],[PpcKF (_,_,_,_,ppc),req],_) =
  StdinSML 1 1 1 1 (RuleFK (Init_Proof (fmz,(dI',pI',mI'))));
> val [(1,[(1,pt)])] = !proofs; (*hier kommen nicht die aktuellen werte ?!?*)
> hide m p pt d;
*)




fun separable_arg ((ID,m):mstep_) = not (mstep2str m = "");
(*> separable_arg (mk_mstep_ (Rewrite ("add_commute","b::rat + a = a + b")));
val it = true : bool
> separable_arg (mk_mstep_ End_Ruleset);
val it = false : bool  *)

exception DIALOG of string;



(*repeat calling ME until nextstep not in hide*)
fun me_repeat_hide (m as (mI,mm)) (pos:pos') (c:cid) 
  (p:ptree) (d as Dstate (hid,_,_,_,_)) = 
  let (*val _= writeln("### vor  me: m  = "^(mstep_2str m));
      val _= writeln("### vor  me: pos= "^(pos'2str pos));
      val _= writeln("### vor  me: ist= "^(istate2str(get_istate p pos)));
      val _= writeln("### vor  me: = "^());*)
      val (pos,c',f,m' as (mI',mm'),s,p) = me m pos c p;
      (*val _= writeln("### nach me: pos= "^(pos'2str pos));
      val _= writeln("### nach me: f  = "^(mout2str f));
      val _= writeln("### nach me: = "^());*)
  in case f of
      Error' _ => raise DIALOG ("me_repeat_hide: "^mI
				^" resulted in Error'")
(*      Error' e => (pos,c@c',f,m':mstep_,s,p) 2.5.01*)
    | _ => 
	  if mm' = Empty_Mstep
	      then (pos,c@c',f,m':mstep_,s,p)
	  else
	      if hide m' pos p d
		  then me_repeat_hide (m':mstep_) pos ((c @ c'):cid) p d
	      else (pos,c@c',f,m':mstep_,s,p) 
  end;



(** determine the next datom **)


(*for testphase*)
fun restrict_dtms SelRule = SelRule    (*rule_dtm*)
  | restrict_dtms dtm = 
  if dtm mem form_dtms then PutRuleRes (*the only form_dtm*)
  else PutRule;                        (*rule_dtm*)

val form_dtms = [PutRes,FillRes,PutRuleRes,FillRuleRes];

fun restrict_dtms dtm act =
    if dtm mem form_dtms then
	let val dtm = case dtm of
		FillRes => PutRes
	      | FillRuleRes => PutRuleRes
	      | x => x;
	    val act = if act = St then Tt else act;
	in (dtm, act) end
    else (*rule_dtms*)
	(case (dtm, act) of
	   (PutRule, St) => (SelRule, St)
	 | (FillRule, St) => (SelRule, St)
	 | xx => xx);


fun continue_pattern (((dp as (c, (_, _, _, _, DPdoneR((str,End_Proof'),_,dc), 
				   pos)))::dps):dps) _ =  (*=========*)
  ((c,(PutRule,Tt,DAundf,None,DPrule((str,End_Proof'),e_mstep_,dc)
       ,pos))::dp::dps):dps

  | continue_pattern ((c, (dtm, act, ErroR, cmd, dph, pos))::dps) d =
  (c, (dtm, act, DAundf,cmd, dph, pos))::
  (c, (dtm, act, ErroR, cmd, set_done' dph, pos))::dps

  | continue_pattern ((dp as (c, (dtm, act, _, _, dph, pos)))::dps) d =
  let 
    (*val _= writeln("#### continue_pattern, before sel_dtm,      dph-dct="^
		   (string_of_int(dct_of dph)));*)
    val (dph,dtm,act) = 
      sel_dtm dph (get_acti d) (get_speed d);
    (*val _= writeln("#### continue_pattern, after sel_dtm,       dtm+act="^
		   (dtm2str dtm)^"+"^(act2str act));*)
    val (dtm,act) = restrict_dtms dtm act; (*TODO !!!*)
    (*val (d,c) = if dtm mem form_dtms then getdecr_cellID d else (d,c);
     not here !.. in do_dtm may be an ErroR*)
    (*val _= writeln("#### continue_pattern, after restrict,      dtm+act="^
		   (dtm2str dtm)^"+"^(act2str act));(**)
    (**)val _= writeln("#### continue_pattern, after sel_dtm,       dph-dct="^
		   (string_of_int(dct_of dph)));*)
  in (c,(dtm,act,DAundf,None,dph,pos))::dp::dps end;

(* use"DG/dialog.sml";
   use"dialog.sml";
   *)



(** dialog atoms **)

  (*PutRule,TskipS -------------- *)
fun do_dtm (p:ptree) (d:dstate) 
  ((dp as (c,(PutRule,TskipS,dast,cmd,
	     dph as DPrule (am,um,dc),pos))::dps):dps) =
  let
    val ef = get_form am pos p;
    val (dp,dats) = case ef of
      Error' e =>
	(set_error dp, 
	 [System("PutRule TskipS failed for \n"^
		 (mstep2str (snd am))^"\n with "^(inout2str e))])
    |  Form' f => 
	((*writeln("###% do_dtm PutRule,TskipS");*)
	(set_done (DPdoneR (am,Form' f,dc)) pos AccepT dp,
	 [RuleKF (EdUndef, snd am)]))
    | x => raise error ("do_dtm PutRule,TskipS: get_form->"^(mout2str x)) 
  in  ([]:cellID list, p, dp, d, dats) end
  
  (*PutRule,Tt ------------------- *)
  | do_dtm p d 
  (dp as (c,(PutRule,Tt,dast,cmd,
	     dph as DPrule (am,um,dc),pos))::dps) =
  ([], p, dp, d, [RuleKF (EdUndef, snd am), Request "Accept ?"])

  (*PutRule,St ------------------- *)
  | do_dtm p d 
  (dp as (c,(PutRule,St,dast,cmd,
	     dph as DPrule (am,um,dc),pos))::dps) =
      ([], p, dp, d, [Request "apply a rule !"])

  (*SelRule,St ------------------- *)
  | do_dtm (pst as pt:ptree) d 
  (dp as (c,(SelRule,St,dast,cmd,
	     dph as DPrule (am,um,dc),pos))::dps) =
  let val sel = sel_rules pt pos;
      (*val _= writeln("#### SelRule,St: after sel");*)
  in([], pst, dp, d, [Select sel, Request "select a rule !"]) end


  (*PutRuleRes,TskipS ------------- *)
  | do_dtm p d 
  (dp as (_,(PutRuleRes,TskipS,_,_,DPform (sr,_,_,dc), pos))::dps) =
  let 
    val (pos',cs,ef,m,s,p) = me_repeat_hide sr pos [] p d;
    (*val _= writeln"### PutRuleRes,TskipS --------------\n";
    val _= writeln (pr_ptree pr_short (snd3 p));*)
    val (d, dp, dat) = case ef of
      Error' e => 
	let val dp = set_error dp;
	in (d, dp, [System ("PutRuleRes TskipS failed for \n"^
			    (mstep_2str sr)^"\n with "^(inout2str e))]) end
    | Form' f => 
	  let
	    val dp = set_done (DPdoneF(m,EmptyMout,dc)) pos' AccepT dp;
	    val (d, dp, dat) = app_dat d dp f;
	  in (d, dp, dat) end;
  in  (cs, p, dp, d, dat) end

  (*PutRuleRes,Tt ------------- *)
  | do_dtm p d 
    (dp as (_,(PutRuleRes,Tt,_,_,DPform (sr,Form' f',f,dc), pos))::dps) =
    let val (d,dp,dat) = app_dat d dp f';
    in ([], p, dp, d, dat @ [Request "Accept ?"]) end
    
  (*PutRes,TskipS ------------- *)
  | do_dtm p d 
    ((dp as (_,(PutRes,TskipS,_,_,DPform (sr,f',f,dc), pos))::dps):dps) =
  let 
    val (pos',cs,ef,m,s,p) = me_repeat_hide sr pos [] p d;
    val (d, dp, dat) = case ef of
      Error' e => 
	let val dp = set_error dp;
	in (d, dp, [System ("PutRuleRes TskipS failed for \n"^
			    (mstep_2str sr)^"\n with "^(inout2str e))]) end
    | Form' f => 
	  let
	    val dp = set_done (DPdoneF(m,EmptyMout,dc)) pos' AccepT dp;
	    val (d, dp, dat) = app_dat d dp f;
	  in (d, dp, dat) end;
  in  (cs, p, dp, d, dat) end
    
  (*PutRes,Tt ------------- *)
  | do_dtm p d 
    (dp as (_,(PutRes,Tt,_,_,DPform (sr,f',f,dc), pos))::dps) =
    let val Form' f''' = (case f' of
	EmptyMout => get_form sr pos p (*a not applicable occurred before*)
      | f'' => f''); 
	val (d,dp,dat) = app_dat d dp f''';
    in ([], p, dp, d, dat @ [Request "Accept ?"]) end

  | do_dtm p d dps  = 
    ((*p___:=p; d___:=d; dps___:=dps;*)
     raise error ("do_dtm not implemented: "^(dps2str dps))
	 );


fun mstep_of (DPdoneR ((_, r),_,_)) = r
  | mstep_of (DPdoneF ((_, r),_,_)) = r
  | mstep_of (DPrule  ((_,sr),(_,ur),_)) = if ur = Empty_Mstep then sr else ur
  | mstep_of (DPform  ((_, r),_,_,_)) = r;

fun last_mstep ((dp as ((_,(_,_,_,_,dph,_))::_)):dps) = mstep_of dph;

(* val dp=dp';val d=d';
   (*for recursions: ...*)
   val cs=cs @ cs';val dats=dats  @ dats';
   *)
fun do_dtms cs p (dp as ((_,(_,_,NoDtm,_,_,_)))::_) dats d =
    (cs, p, dp, d, dats)
  | do_dtms cs p (dp as ((_,(_,_,FixDtm,_,_,_)))::_) dats d =
    do_dtm p d dp

  | do_dtms cs p dp dats d =
  if last_mstep dp = End_Proof' 
    then (cs, p, dp, d, dats @ [Request "start another example", End_Proof])
  else
    let 
    (*val _= writeln("### do_dtms, bef.continue_pattern, d-dct="^
		       ((string_of_int o get_dct) d));(**)
    (**)val _= writeln("### do_dtms, bef.continue_pattern,          dps-dct="^
		    ((string_of_int o last_dct) dp));*)
      val dp = continue_pattern dp d;
    (*val _= writeln("### do_dtms, after continue_pat,dp =\n"^(dps2str dp));*)
      val (cs',p,dp,d,dats') = do_dtm p d dp;
    (*val _= writeln("### do_dtms,after do_dtm,          d-dct="^
		       ((string_of_int o get_dct) d));(**)
    (**)val _= writeln("### do_dtms,after do_dtm,                   dps-dct="^
		    ((string_of_int o last_dct) dp));*)
    (*val _= writeln("### do_dtms, after do_dtm, dp =\n"^(dps2str dp));*)
    in case hd dp of 
      (_,(_,_,ErroR,_,_,_))  => (cs @ cs', p, dp:dps, d, dats  @ dats')
    | (_,(_,TskipS,_,_,DPdoneR ((_,Empty_Mstep),_,_),_)) => 
	(cs @ cs', p, dp:dps, d, dats  @ dats' (*@
	 [Message "no next step can be proposed"]*)) 
    | (_,(_,TskipS,_,_,DPdoneF ((_,Empty_Mstep),_,_),_)) => 
	(cs @ cs', p, dp:dps, d, dats  @ dats' (*@
	 [Message "no next step can be proposed"]*))
    | (_,(_,TskipS,_,_,_,_)) => do_dtms (cs @ cs') p dp (dats  @ dats') d
    | _ => (cs @ cs', p, dp:dps, d, dats  @ dats') end;
	



(*=========St*)
(*------------DPrule*)
fun resume_St_DPrule_Command (p:ptree) (dp:dps)
  (d:dstate) (sr:mstep_, ur:mstep_, dc:dct) (cmd':user_cmd) =
  case cmd' of
    YourTurn =>
      ([]:cid, p, set_broken dp, set_acti ~1 d, [])
  | Rules =>
      let val ((_,(_,_,_,_,_,pos))::_) = dp;
	  val pt = p;
      in ([], p, repeat_dtm_cmd Rules dp, d, [Select (sel_rules pt pos)]) end
  | Auto =>
      ([], p, ((set_dph_dct 9999) o (add_dps_cmd Auto)) dp, 
       ((set_acti 0) o (set_speed 3(*sel_dtm: formulae + rules*))) d, [])
  | SpeedPlus =>
      let val d = incr_speed d;
      in ([], p, repeat_dtm_cmd SpeedPlus dp, d, [Speed (get_speed d)]) end
  | SpeedMinus => 
      let val d = decr_speed d;
      in ([], p, repeat_dtm_cmd SpeedPlus dp, d, [Speed (get_speed d)]) end
  | ActivePlus => 
      let val s = get_acti d;
      val s = if s > 6 then s else s + 1;
      in ([], p, repeat_dtm_cmd ActivePlus dp, set_acti s d, [Active s]) end
  | ActiveMinus => 
      let val s = get_acti d;
      val s = if s > 0 then s - 1 else s;
      in ([], p, repeat_dtm_cmd ActiveMinus dp, set_acti s d, [Active s]) end
  | _ =>
      ([], p, dp, d, [System((cmd2str (Some cmd'))^
			      " not impl. in resume_St_DPrule_Command")]);
(*St:data ... cmd not expected*)
(*example,howcomes,whatfor: dpst ganz neu
 forward,back,undo ???
 yourturn,myturn,dontknow, notaccept: continue variiert
 accept: einfach wiederholen
 notaccept=dontknow: 
 rules: liefert vorbereitende Infor f"ur curr.dtm
 *)

fun resume_St_DPrule_FoPpcFK (p:ptree) (dp:dps) (d:dstate)
  (sr:mstep_,ur:mstep_,dc:dct) (f:foppFK) =
  (*wechsle dph auf 1,
   applicable -> 2b, not -> 2a*)
  ([]:cid, p, dp, d, [System"resume_St_DPrule_FoPpcFK not impl."]);

fun resume_St_DPrule_RuleFK (p:ptree) 
  ((dp as (c, (dtm,act,dast,cmd,dph,pos))::dps):dps)
  (d:dstate) (sr:mstep_, ur:mstep_ , dc:dct) (r:mstep) =
  let
    (*val _= writeln("####### resume_St_DPrule_RuleFK, begin");*)
    val m = mk_mstep_ r;
    val ef = get_form m pos p;
    val (dp',dats) = case ef of
      Error' e => 
	let val dp = set_error dp;
	in (dp, [Error_ (inout2str e)]) end
    |  Form' f =>
	let val dp = set_done (DPdoneR(m,Form' f,dc)) pos AccepT dp;
	in (dp, []) end;
  in  ([], p, dp', d, dats) end;


(*------------DPform*)
fun resume_St_DPform_Command p 
  ((dp as (c, (dtm, act, dast, cmd, dph, pos))::dps):dps)
   d (au,sf,uf,dc) cmd' =
  (*S:data ... cmd not expected*)
  (*example,howcomes,whatfor: sinnvoll !
   forward,back,undo ???
   yourturn:  dhpase bleibt, act -> Tt
   myturn:    ??
   dontknow, notaccept:
   accept:    gleiche dph wiederholen
   notaccept: ??
   rules:     zur"uck auf DPrule, sinnvoll 
     *)
  ([]:cid, p, dp:dps , d,[System"resume_St_DPform_Command not impl."]);

fun resume_St_DPform_FoPpcFK p 
  ((dp as (c, (dtm, act, (*skip,*) dast, cmd, dph, pos))::dps):dps)
    d (au,sf,uf,dc) f =
  (*normalfall: wenn f =(parsed)= DPform (_,f), 
   dann 
   val ( , ,f, , ) = me_repeat_hide ... (18.12.99)
     
     
     let val (pos, cs, ef, m, s, p) = 
       me_repeat_hide (mk_mstep_ f) pos [c] p d;
		in case ef of 
		  Error' e => 
    | Form' mo => raise DIALOG "test"
		    *)
  ([]:cid, p, dp:dps, d, [System"resume_St_DPform_FoPpcFK not impl."]);

fun resume_St_DPform_RuleFK p 
  ((dp as (c, (dtm, act, (*skip,*) dast, dmc, dph, pos))::dps):dps) 
    d (au,sf,uf,dc) r =
  (*geht im selben dstep zur"uck auf 2a | 2ai*)
   ([]:cid, p, dp:dps , d, [System"resume_St_DPform_RuleFK not impl."]);
   

(*=========Tt*)
(*------------DPrule*)
fun resume_Tt_DPrule_Command p 
  ((dp as (c, (dtm, act, dast, cmd, dph, pos))::dps):dps) 
    d (sr,ur,dc:dct) cmd' =
  (*St:ackonwledge ... cmd expected*)
   (*example,howcomes,whatfor,dontknow:
    forward,back,undo ???
    notaccept: sinnvoll -- pattern "T: explains 'howcomes'
    rules:     die andgeforderte r droht ur zu "uberschreiben
    im n"achsten Schritt (nicht hier in diesem 
    *)
    case cmd' of
	Accept =>
	  let val ef = get_form sr pos p;
	      val (dp',dats) = case ef of
		  Error' e => 
		      let val dp = set_error dp;
		      in (dp, [System (*Tt !!!*) (inout2str e)]) end 
		|  Form' f =>
		      let val dp = set_done (DPdoneR (sr, Form' f, dc)) 
			  pos AccepT dp;
		      in (dp, []) end;
	  in  ([], p, dp', d, dats) end
      | Rules => (*Broken @@@*)
	  let val dp' = ((add_fix SelRule St) o (set_broken_cmd Rules)) dp;
	  in  ([], p, dp', d, []) end
      | YourTurn => (*implicit Accept*)
	  let val ef = get_form sr pos p;
	      val (dp',dats) = case ef of
		  Error' e => 
		      let val dp = set_error dp;
		      in (dp, [System (*Tt !!!*) (inout2str e)]) end 
		|  Form' f =>
		      let val dp = set_cmd YourTurn dp;
			  val dp = set_done (DPdoneR (sr, Form' f, dc)) 
			  pos AccepT dp;
		      in (dp, []) end;
	  in  ([], p, dp', d, dats) end
   | Auto =>
      ([], p, ((set_dph_dct 9999) o (add_dps_cmd Auto)) dp, 
       ((set_speed 3) o (set_acti 0)) d, [])
   | SpeedPlus => (*implicit Accept ??? NOT CLEAR !!!31.10.00*)
      let val d = incr_speed d;
      in ([], p, repeat_dtm_cmd SpeedPlus dp, d, [Speed (get_speed d)]) end
   | SpeedMinus => 
      let val d = decr_speed d;
      in ([], p, repeat_dtm_cmd SpeedPlus dp, d, [Speed (get_speed d)]) end
   | ActivePlus => (*previous dtm once more*)
      let val s = get_acti d;
      val s = if s > 6 then s else s + 1;
      in ([], p, repeat_dtm_cmd ActivePlus dp, set_acti s d, [Active s]) end
   | ActiveMinus => 
      let val s = get_acti d;
      val s = if s > 0 then s - 1 else s;
      in ([], p, repeat_dtm_cmd ActiveMinus dp, set_acti s d, [Active s]) end
   | cc => 
	   ([]:cid, p, dp:dps, d, 
	    [System ("resume_Tt_DPrule_Command: not impl. for "^
		      (cmd2str (Some cc)))]);
	   
fun resume_Tt_DPrule_FoPpcFK p 
  ((dp as (c,  (dtm, act, (*skip,*) dast, cmd, dph, pos))::dps):dps)
    d (sr,ur,dc:dct) f =
  (*implicit S:Accept f"ur sr?ur, check new f*)
   ([]:cid, p, dp:dps, d, [System"resume_Tt_DPrule_FoPpcFK not impl."]);


fun resume_Tt_DPrule_RuleFK p
  ((dp as (c, (dtm, act, dast, cmd, dph, pos))::dps):dps) 
    d (sr,ur,dc:dct) r =
    (*r "uberschreibt ur *)
  let
    val m = mk_mstep_ r;
    val ef = get_form m pos p;
    val (dp',dats) = case ef of
      Error' e => 
	(set_error dp, [Error_ (inout2str e)])
    |  Form' f =>
	(if m = sr 
	     then  (set_done (DPdoneR(m,Form' f,dc)) pos AccepT dp, [])
	 else (((add_dps (PutRule,St,AccepT,Some MyTurn,
			  DPdoneR (m,Form' f,dc),pos)) o set_broken) dp,
	       []));
  in  ([], p, dp', d, dats) end;


(*Tt presented a formula, St answered with command*)
fun resume_Tt_DPform_Command p 
  ((dp as (c, (dtm, act, dast, cmd, _, pos))::dps):dps) 
   d (au,sf,uf,_) cmd' =
    (*example,howcomes,whatfor,dontknow: 
     forward,back,undo ???
     yourturn,myturn:     impl.S:accept ! *)
    (*notaccept: sinnvoll -- pattern "Tt: explains 'howcomes'
     rules:     impl.S:accept !
     *)    
   case cmd' of   
     Accept => (* sf proposed by ME, gen.by au, thus error-check superfluous *)
       let (*val _= writeln("#### resume_Tt_DPform_Command");*)
	 val (pos,cs,ef,m,s,p) = me_repeat_hide au pos [] p d;
	 val (dp,dats) = case ef of
	   Error' e => 
	     let val dp = set_error dp;
	     in (dp, [Error_ (inout2str e)]) end
	 |  Form' f => 
	     let val dp = set_done(DPdoneF(m, EmptyMout, get_dct d)) pos AccepT dp
	     in (dp, []) end
       in  ([], p, dp, d, dats) end
   | Rules => (*implicit Accept*)
       let val (pos,cs,ef,m,s,p) = me_repeat_hide au pos [] p d;
	 val (dp,dats) = case ef of
	   Error' e => 
	     let val dp = set_error dp;
	     in (dp, [Error_ (inout2str e)]) end
	 | Form' f => 
	     let val dp =
		 ((add_dps (SelRule,St,FixDtm,None,DPrule(m,e_mstep_,0),pos)) o
		  (set_cmd Rules) o 
		  (set_done (DPdoneF (m, EmptyMout, get_dct d)) pos AccepT))dp;
	     in (dp, []) end
       in  ([], p, dp, d, dats) end
   | YourTurn => (*implicit Accept*)
       let val (pos,cs,ef,m,s,p) = me_repeat_hide au pos [] p d;
	 val (dp,dats) = case ef of
	   Error' e => 
	     let val dp = set_error dp;
	     in (dp, [Error_ (inout2str e)]) end
	 |  Form' f => 
	     let val dp = set_done(DPdoneF(m, EmptyMout, get_dct d)) pos AccepT dp
	     in (dp, []) end
       in  ([], p, dp, d, dats) end
   | Auto =>
       ([], p, ((set_dph_dct 9999) o (add_dps_cmd Auto)) dp, 
       ((set_speed 3) o (set_acti 0)) d, [])
   | SpeedPlus => (*implicit Accept ??? NOT CLEAR !!!31.10.00*)
      let val d = incr_speed d;
      in ([], p, repeat_dtm_cmd SpeedPlus dp, d, [Speed (get_speed d)]) end
   | SpeedMinus => 
      let val d = decr_speed d;
      in ([], p, repeat_dtm_cmd SpeedPlus dp, d, [Speed (get_speed d)]) end
   | ActivePlus => (*previous dtm once more*)
      let val s = get_acti d;
      val s = if s > 6 then s else s + 1;
      in ([], p, repeat_dtm_cmd ActivePlus dp, set_acti s d, [Active s]) end
   | ActiveMinus => 
      let val s = get_acti d;
      val s = if s > 0 then s - 1 else s;
      in ([], p, repeat_dtm_cmd ActiveMinus dp, set_acti s d, [Active s]) end
   | _ => 
      ([], p, dp, d, [System((cmd2str (Some cmd'))^
			      " not impl. in resume_St_DPrule_Command")]);






(* use"DG/dialog.sml";
   use"dialog.sml";
   *)



fun resume_Tt_DPform_FoPpcFK p 
  ((dp as (c, (dtm, act, dast, cmd, dph, pos))::dps):dps)  
    d (au,sf,uf,dc) f =
  (*implic.St:accept der sf, abschliessen, check f*)
  ([]:cid, p, dp:dps, d, [System"resume_Tt_DPform_FoPpcFK not impl."]);


(* val (dp as (c, (dtm, act, dast, cmd, dph, pos))::dps)=dp;
   resume_Tt_DPform_RuleFK p 
  (((c, (dtm, act, dast, cmd, dph, pos))::dps):dps) 
  d (au,sf,uf,dc) r; 
   *)
(*Tt presented a formula sf, asking 'Accept ?' | 'Select a rule !' ...,
  St answers with Rule r, supposed to be applied to sf (implicit accept)*)
fun resume_Tt_DPform_RuleFK p 
  ((dp as (c, (dtm, act, dast, cmd, dph, pos))::dps):dps) 
  d (au,sf,uf,dc) r =
  let
    (*val _= writeln("###% resume_dpst T DPform RuleFK, dc = "^
		   (string_of_int dc));*)
    val dp = set_dast dp AccepT; (*implicit accept !*)
    val (pos,cs,ef,m,s,p) = me_repeat_hide au pos [] p d;(*14.10.00 repeat?!?*)
  in case ef of
    Error' e => 
      ([]:cid, p, set_error dp, d, 
	  [System ("resume_Tt_DPform_RuleFK failed for \n"^
		   (mstep_2str au)^"\n with "^(inout2str e))])
  | Form' f =>
      (* val Form' f=ef;
         *)
      let val m = mk_mstep_ r;
      in case get_form m pos p of
	 Error' e => 
	   ([], p, add_dps (PutRule,St,ErroR,Some MyTurn,
			    (*DPdoneR (m,EmptyMout,dc),pos) dp 2.Feb.01*)
			    DPrule (au, m, dc), pos) dp, 
	    d, [Error_ (inout2str e)])
       | Form' f => 
	   ((*writeln("###% resume_dpst T DPform RuleFK, dc = "^
		   (string_of_int dc));*)
	   ([],p, add_dps (PutRule,St,AccepT,Some MyTurn,
			   DPdoneR (m,Form' f,dc),pos) dp, d, []))
      end
  end;

(*=========TskipS, 2.5.01*)
(*------------Command*)
(*2.5.01: weiter nach Auto -> helpless: voriges result schon in pt*)
fun resume_TskipS_DPdoneF_Command p 
  ((dp as (c, (dtm, act, dast, cmd, _, pos))::dps):dps) d cmd' =
  case cmd' of   
    Accept => ([], p, repeat_dtm_cmd Accept dp, d, [])
  | Rules => ([], p, ((add_fix SelRule St) o (set_broken_cmd Rules)) dp, d, [])
  | YourTurn => ([], p, repeat_dtm_cmd YourTurn dp, d, 
		 [Message "no next step can be proposed"])
  | Auto => ([], p, repeat_dtm_cmd YourTurn dp, d, 
		 [Error_ "no next step can be proposed"])
  | SpeedPlus => 
      let val d = incr_speed d;
      in ([], p, repeat_dtm_cmd SpeedPlus dp, d, [Speed (get_speed d)]) end
   | SpeedMinus => 
      let val d = decr_speed d;
      in ([], p, repeat_dtm_cmd SpeedPlus dp, d, [Speed (get_speed d)]) end
   | ActivePlus => (*previous dtm once more*)
      let val s = get_acti d;
      val s = if s > 6 then s else s + 1;
      in ([], p, repeat_dtm_cmd ActivePlus dp, set_acti s d, [Active s]) end
   | ActiveMinus => 
      let val s = get_acti d;
      val s = if s > 0 then s - 1 else s;
      in ([], p, repeat_dtm_cmd ActiveMinus dp, set_acti s d, [Active s]) end
   | cc => 
	   ([]:cid, p, dp:dps, d, 
	    [System ("resume_Tt_DPrule_Command: not impl. for "^
		      (cmd2str (Some cc)))]);



(*2.5.01: weiter nach Auto -> helpless: voriges result schon in pt*)
fun resume_TskipS_DPdoneF_RuleFK p 
  ((dp as (c, (dtm, act, dast, cmd, dph, pos))::dps):dps) d r = 
  let val m = mk_mstep_ r;
    val dc = get_dct' d;
  in case get_form m pos p of
    Error' e => 
      ([], p, add_dps (PutRule,St,ErroR,None,
		       DPrule (e_mstep_, m, dc), pos) dp, 
       d, [Error_ (inout2str e)])
  | Form' f => 
      ((*writeln("###% resume_dpst T DPform RuleFK, dc = "^
	(string_of_int dc));*)
       ([],p, add_dps (PutRule,St,AccepT,Some MyTurn,
		       DPdoneR (m,Form' f,dc),pos) dp, d, []))
  end;


(* val (dp as (c, (dtm, act, dast, cmd, dph, pos))::dps)=dp;
   resume_dpst (p:ptree)(((c, (dtm, act, dast, cmd, dph, pos))::dps):dps) 
     (d:dstate) (dat:inout);
   *)
(*resume from St-input*)
fun resume_dpst (p:ptree)
 ((dp as (c, (dtm, act, dast, cmd, dph, pos))::dps):dps) 
  (d:dstate) (dat:inout) =
  let val dph' = init_dct d dph;
    (*val _= writeln("### resume_dpst begin,dct= "^(string_of_int(dct_of dph')));*)
  in case act of
    St =>             (*input from St:data *)
      (case dph' of      (*dph is as left before prompt St:*)
	 DPrule (sr,ur,dc) =>
	   (case dat of
	      Command cmd' => (*St:data ... cmd' not expected*)
		resume_St_DPrule_Command p dp d (sr,ur,dc) cmd'
	    | FoPpcFK f => 
		resume_St_DPrule_FoPpcFK p dp d (sr,ur,dc) f
	    | RuleFK r => (* usecase 2/4 *)
		resume_St_DPrule_RuleFK p dp d (sr,ur,dc) r)
       | DPform (au,sf,uf,dc) =>
	    (case dat of
	       Command cmd' => (*S:data ... cmd' not expected*)
		 resume_St_DPform_Command p dp d (au,sf,uf,dc) cmd'
	     | FoPpcFK f => 
		 resume_St_DPform_FoPpcFK p dp d (au,sf,uf,dc) f
	     | RuleFK r => 
		 resume_St_DPform_RuleFK p dp d (au,sf,uf,dc) r)
       | _ => raise DIALOG "TODO dhpase 2ai")
 | Tt =>               (*input from S:ackowledge*)
     (case dph' of      (*dph is as left before prompt St:*)
	DPrule (sr,ur,dc) =>
	  (case dat of
	     Command cmd' => (*St:ackonwledge ... cmd' expected*)
	       resume_Tt_DPrule_Command p dp d (sr,ur,dc) cmd'
	   | FoPpcFK f => 
	       resume_Tt_DPrule_FoPpcFK p dp d (sr,ur,dc) f
	   | RuleFK r => 
	       resume_Tt_DPrule_RuleFK p dp d (sr,ur,dc) r)
      | DPform (au,sf,uf,dc) =>
	   (case dat of
	      Command cmd' => (*St:ackonwledge ... cmd' expected*)
	       resume_Tt_DPform_Command p dp d (au,sf,uf,dc) cmd'
           | FoPpcFK f =>
	       resume_Tt_DPform_FoPpcFK p dp d (au,sf,uf,dc) f
	   | RuleFK r => 
	      (*val DPform (au,sf,uf,dc)=dph';
                val RuleFK r=dat;
	       *)
	       resume_Tt_DPform_RuleFK p dp d (au,sf,uf,dc) r)
      | _ => raise error "TODO dhpase 2ai")
 | TskipS =>            (*if do_dtms left due Empty_Mstep,2.5.01*)
     (case dph' of      (*dph is as left before prompt St:*)
	DPrule (sr,ur,dc) =>
	  (case dat of
	     Command cmd' => (*St:ackonwledge ... cmd' expected*)
	       resume_Tt_DPrule_Command p dp d (sr,ur,dc) cmd'
	   | FoPpcFK f => 
	       resume_Tt_DPrule_FoPpcFK p dp d (sr,ur,dc) f
	   | RuleFK r => 
	       resume_Tt_DPrule_RuleFK p dp d (sr,ur,dc) r)
      | DPform (au,sf,uf,dc) =>
	   (case dat of
	      Command cmd' => (*St:ackonwledge ... cmd' expected*)
	       resume_Tt_DPform_Command p dp d (au,sf,uf,dc) cmd'
           | FoPpcFK f =>
	       resume_Tt_DPform_FoPpcFK p dp d (au,sf,uf,dc) f
	   | RuleFK r => 
	      (*val DPform (au,sf,uf,dc)=dph';
                val RuleFK r=dat;
	       *)
	       resume_Tt_DPform_RuleFK p dp d (au,sf,uf,dc) r)
      | DPdoneF _ => 
	  (case dat of
	     Command cmd' => resume_TskipS_DPdoneF_Command p dp d cmd'
	   | FoPpcFK f => raise error "TODO resume_TskipS_DPdoneF_FoPpcFK"
	   | RuleFK r => resume_TskipS_DPdoneF_RuleFK p dp d r
	       )
      | _ => raise error "TskipS => TODO dhpase 2ai")
 | _ => ([]:cid, p, dp, d, 
	 [System ("failed to resume "^
		  ((pair2str o (apfst string_of_int) o 
		    (apsnd dpst2str)) (hd dp)))]) end;





fun init_dpst (c:cellID) (Init_Proof e) (d:dstate as Dstate (_,acti,speed,_,_)) =
  let
    val m = mk_mstep_(Init_Proof e);
    (*val d = default_dstate; 30.10.00 -> New_User*)
    (*val ef = get_form m e_pos' empty_pstate;*)
    val (pos,cs,ef,m,s,p) = me_repeat_hide m e_pos' [] EmptyPtree d;
    val (dp',dats) = case ef of
      Error' err => 
	([(c,(PutRule, TskipS, ErroR, None, 
	      DPdoneR(mk_mstep_ (Init_Proof e),EmptyMout,0),([],Pbl)))],
	 [Error_ "example not accept"])
    |  Form' f => 
	([(c,(PutRule, TskipS, AccepT, None, 
	      DPdoneR(mk_mstep_ (Init_Proof e),Form' f,(get_dct d)-1),(*TskipS*)
	      ([],Pbl)))],
	 []);
  in ([]:cellID list, p, dp', d, dats @ [Active acti, Speed speed]) end;






(*in dps one cellID may address several dpst; 
  the dpsts are _PRE_pended during history of dialog, 
  thus the latest worked on is in front of the others;

  in case an elder cellID has been touched on the FE
  the dpst found is made the head of the dps*)
fun dpst_athead (dps:dps,c) = 
  let 
    fun ass done ([],c) = 
	raise error ("call_DG_ME: acellID "^(string_of_int c)^" is unknown")
      | ass done ((ci, xi) :: pairs, c:cellID) =
	    if c = ci 
		then ((ci, xi) :: (done @ pairs)):dps
	    else ass  (done @ [(ci, xi)]) (pairs, c);
  in ass [] (dps,c) end;
(* val dps = [(3,e_dpst),(2,e_dpst),(1,e_dpst)]:dps;
> dpst_athead (dps,2);
val it =
  [(2,(Prompt,Tt,SkipUdf,DAundf,None,DPdone,(#,#))),
   (3,(Prompt,Tt,SkipUdf,DAundf,None,DPdone,(#,#))),
   (1,(Prompt,Tt,SkipUdf,DAundf,None,DPdone,(#,#)))] : dps *)


(*11.10.00:call_DG_ME
args:
   p  :
   dp :
   d  :
   ac : cellID (known in dps) above the current cellID
   c  : current cellID (generated by FE)
   dat:
values:
   cs  :
   dats:
   ns  : ////after 23.5.00
   p   :
   dp  :
   d   :
*)
(* val p=get_proof uI pI;val dp=get_dps uI pI;val d=get_dstate uI;
   val (ac,c)=(acI,cI);
*)
fun call_DG_ME (p:ptree) (dp:dps) (d:dstate)
  (ac:cellID, c:cellID) (dat:inout) =
  case dat of
      (RuleFK (Init_Proof e)) => 
	  let val (cs,p,dp',d',dats) = init_dpst c (Init_Proof e) d;
    (*val _ = writeln("## call_DG_ME,nach init_dpst,      d-dct="^
		    ((string_of_int o get_dct) d'));(**)
    (**)val _ = writeln("## call_DG_ME,nach init_dpst,               dps-dct="^
		    ((string_of_int o last_dct) dp'));*)
    (*val _= writeln("###% call_DG_ME: after init_dpst | resume_dpst, dp'=\n"^
		   (dps2str dp'));*)
    (*val _= writeln("###% call_DG_ME: after init_dpst | resume_dpst, d'= "^
		   (d2str d'));*)
	  in do_dtms cs p dp' dats d' end
    | _ => 
	  let val dp as ((_,(_,_,_,_,_,pos))::_) = dpst_athead (dp,ac);
	  in if pos = ([],Res)
		 then ([], p, dp, d, [Message "end of example"])
	     else let val (cs,p,dp',d',dats) = resume_dpst p dp d dat;
    (*val _ = writeln("## call_DG_ME,nach resume_dpst,    d-dct="^
		    ((string_of_int o get_dct) d'));
    (**)val _ = writeln("## call_DG_ME,nach resume_dpst,             dps-dct="^
		    ((string_of_int o last_dct) dp'));*)
    (*val _= writeln("###% call_DG_ME end, dp' =\n"^(dps2str dp'));*)
    (* val d = update_dstate ... TODO*)
		  in do_dtms cs p dp' dats d' end
	  end;


(* use"DG/dialog.sml";
   *)
